/*
	$Id: wvlan_proc.c,v 1.3 2001/04/06 20:56:05 tobi Exp $
*/

#include <stdio.h>
#include <malloc.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <stdlib.h>
#include <unistd.h>

#include "wvlan_mon.h"

my_info *get_dev () {
	FILE *fp;
	char *ptr=NULL;
	char *newptr=NULL;
	int size,i,n;
	my_info *info;

	info=calloc(sizeof(my_info),1);

	if(!(fp=fopen(DEV,"r"))) {
		return NULL;
	}

	ptr=calloc(1024,1);

	size=fread(ptr,1,1024,fp);
	fclose(fp);

	n=0;

	for(i=0;i<size;i++) {
		if(ptr[i]=='\n') {
			n++;
		}
		if(n==2 && !newptr) {
			newptr=ptr+i+1;
		}
	}

	if(newptr=="" || !newptr) {
		free(ptr);
		free(info);
		return NULL;
	}
	n=strlen(newptr);
	if(n==0) {
		free(ptr);
		free(info);
		return NULL;
	}	

	newptr[n-1]='\0';

	info->netdev=calloc(1024,1);
	i=sscanf(newptr,"%s %d %d. %d. %d. %d %d %d",info->netdev,
						      &info->status,
						      &info->linkq,
						      &info->level,
						      &info->noise,
						      &info->err_nwid,
						      &info->err_crypt,
						      &info->err_misc);
	free(ptr);
	n=strlen(info->netdev);
	info->netdev[n-1]='\0';
	if(!g_strcasecmp(info->netdev,NETDEV)) {
		return info;
	} else {
		return NULL;
	}
}
